1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
5 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
6 CERROR
="\e[1;31m" # red
7 CWARNING
="\e[1;33m" # yellow
8 CMSG
="\e[1;32m" # green
9 CINFO
="\e[1;96m" # light blue
10 CDEBUG
="\e[1;94m" # blue
11 CNORMAL
="\e[0;39m" # default system console color
12 CDONE
="\e[1;32m" # green
13 CPASS
="\e[1;32m" # green
14 CFAIL
="\e[1;31m" # red
15 CCMD
="\e[1;35m" # pink
18 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
21 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
33 if [ -n "$1" ]; then shift; else break; fi
35 echo -n "…${CNORMAL} " >&2;
37 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
41 # enable / disable Debugging
42 MSGLEVEL
=${MSGLEVEL:-3}
43 if [ $MSGLEVEL -le 0 ]; then
46 if [ $MSGLEVEL -le 1 ]; then
50 if [ $MSGLEVEL -le 2 ]; then
54 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
56 if [ -n "$CFAIL" ]; then
57 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
59 msgfail
() { echo -n " ###FAILED###" >&2; }
62 if [ $MSGLEVEL -le 3 ]; then
66 if [ $MSGLEVEL -le 4 ]; then
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
78 echo "${CDONE}DONE${CNORMAL}" >&2;
83 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
84 if [ -f .
/aptconfig.conf
]; then
85 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
86 elif [ -f ..
/aptconfig.conf
]; then
87 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
89 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
92 aptconfig
() { runapt apt
-config $
*; }
93 aptcache
() { runapt apt
-cache $
*; }
94 aptcdrom
() { runapt apt
-cdrom $
*; }
95 aptget
() { runapt apt
-get $
*; }
96 aptftparchive
() { runapt apt
-ftparchive $
*; }
97 aptkey
() { runapt apt
-key $
*; }
98 aptmark
() { runapt apt
-mark $
*; }
100 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
103 if [ -f .
/aptconfig.conf
]; then
104 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
105 elif [ -f ..
/aptconfig.conf
]; then
106 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
108 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
113 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
117 CURRENTTRAP
="$CURRENTTRAP $1"
118 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
122 TMPWORKINGDIRECTORY
=$(mktemp -d)
123 TESTDIRECTORY
=$(readlink -f $(dirname $0))
124 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
125 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
126 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
127 local OLDWORKINGDIRECTORY
=$(pwd)
128 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
129 cd $TMPWORKINGDIRECTORY
130 mkdir rootdir aptarchive keys
132 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
133 mkdir -p var
/cache var
/lib var
/log
134 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
135 touch var
/lib
/dpkg
/available
137 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
139 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
140 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
141 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
143 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
144 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
145 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
147 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
148 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
149 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
150 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
151 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
152 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
153 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
154 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
155 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
158 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
159 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev
/null
; then
160 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
162 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
163 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
165 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
170 if [ "$1" = "native" -o -z "$1" ]; then
171 eval `aptconfig shell ARCH APT::Architecture`
172 if [ -n "$ARCH" ]; then
175 dpkg
--print-architecture
183 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
186 configarchitecture
() {
187 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
189 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
191 while [ -n "$1" ]; do
192 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
199 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
200 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
201 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
202 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
204 echo -n > rootdir/var/lib/dpkg/status
207 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
208 local ARCHS="$(getarchitectures)"
209 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
210 DPKGARCH="$(dpkg --print-architecture)"
211 for ARCH in ${ARCHS}; do
212 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
214 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
215 # dpkg doesn't really check the version as long as it is fully installed,
216 # but just to be sure we choose one above the required version
217 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
223 setupsimplenativepackage() {
227 local RELEASE="${4:-unstable}"
228 local DEPENDENCIES="$5"
229 local DESCRIPTION="$6"
230 local SECTION="${7:-others}"
232 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
235 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
237 local BUILDDIR=incoming/${NAME}-${VERSION}
238 mkdir -p ${BUILDDIR}/debian/source
240 echo "* most suckless software product ever
" > FEATURES
241 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
242 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
246 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
247 test -e debian/control || echo "Source
: $NAME
250 Maintainer
: Joe Sixpack
<joe@example.org
>
251 Build
-Depends: debhelper
(>= 7)
252 Standards
-Version: 3.9.1
254 Package
: $NAME" > debian/control
255 if [ "$ARCH" = 'all' ]; then
256 echo "Architecture
: all
" >> debian/control
258 echo "Architecture
: any
" >> debian/control
260 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
261 if [ -z "$DESCRIPTION" ]; then
262 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
263 If you
find such a package installed on your system
,
264 YOU did something horribly wrong
! They are autogenerated
265 und used only by testcases
for APT and surf no other propose…
" >> debian/control
267 echo "Description
: $DESCRIPTION" >> debian/control
269 test -e debian/compat || echo "7" > debian/compat
270 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
271 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
275 buildsimplenativepackage() {
279 local RELEASE="${4:-unstable}"
280 local DEPENDENCIES="$5"
281 local DESCRIPTION="$6"
282 local SECTION="${7:-others}"
283 local PRIORITY="${8:-optional}"
285 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
288 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
290 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
292 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
293 mkdir -p $BUILDDIR/debian/source
294 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
296 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
298 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
299 echo "$NAME ($VERSION) $RELEASE; urgency
=low
303 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
307 Maintainer
: Joe Sixpack
<joe@example.org
>
308 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
309 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
310 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
312 Package
: $NAME" >> ${BUILDDIR}/debian/control
314 if [ "$ARCH" = 'all' ]; then
315 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
317 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
319 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
320 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
321 if [ -z "$DESCRIPTION" ]; then
322 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
323 If you
find such a package installed on your system
,
324 YOU did something horribly wrong
! They are autogenerated
325 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
327 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
330 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
331 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
333 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
334 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
335 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
336 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
337 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
338 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
342 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
343 rm -rf ${BUILDDIR}/debian
/tmp
344 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
345 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
346 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
347 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
348 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
350 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
351 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
354 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
355 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
356 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
365 local ARCH
=$(getarchitecture $4)
366 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
368 if [ "$ARCH" = "all" ]; then
369 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
371 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
372 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
373 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
376 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
379 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
385 if [ -d incoming
]; then
386 buildaptarchivefromincoming $
*
388 buildaptarchivefromfiles $
*
392 createaptftparchiveconfig
() {
393 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
394 if [ -z "$ARCHS" ]; then
395 # the pool is empty, so we will operate on faked packages - let us use the configured archs
396 ARCHS
="$(getarchitectures)"
399 ArchiveDir "' >> ftparchive.conf
400 echo -n $(readlink -f .) >> ftparchive.conf
402 CacheDir "' >> ftparchive.conf
403 echo -n $(readlink -f ..) >> ftparchive.conf
405 FileListDir "' >> ftparchive.conf
406 echo -n $(readlink -f pool/) >> ftparchive.conf
410 Packages::Compress ". gzip bzip2 lzma xz";
411 Sources::Compress ". gzip bzip2 lzma xz";
412 Contents::Compress ". gzip bzip2 lzma xz";
413 Translation::Compress ". gzip bzip2 lzma xz";
414 LongDescription "false";
418 SrcDirectory "pool/";
424 Label "apttestcases";
426 Description "repository with dummy packages";
427 Architectures "' >> ftparchive.conf
428 echo -n "$ARCHS" >> ftparchive.conf
432 };' >> ftparchive.conf
433 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
434 echo -n 'tree "dists/' >> ftparchive.conf
435 echo -n "$DIST" >> ftparchive.conf
437 Architectures "' >> ftparchive.conf
438 echo -n "$ARCHS" >> ftparchive.conf
440 FileList "' >> ftparchive.conf
441 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
443 SourceFileList "' >> ftparchive.conf
444 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
446 Sections "' >> ftparchive.conf
447 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
449 };' >> ftparchive.conf
453 buildaptftparchivedirectorystructure
() {
454 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
455 for DIST
in $DISTS; do
456 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
457 for SECTION
in $SECTIONS; do
458 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
459 for ARCH
in $ARCHS; do
460 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
462 mkdir -p dists
/${DIST}/${SECTION}/source
463 mkdir -p dists
/${DIST}/${SECTION}/i18n
473 local DEPENDENCIES
="$5"
474 local PRIORITY
="${6:-optional}"
476 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
477 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
478 ARCHS
="$(getarchitectures)"
482 for BUILDARCH
in $ARCHS; do
483 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
484 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
485 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
486 local FILE
="${PPATH}/Packages"
491 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
492 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
493 echo "Version: $VERSION
494 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
495 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
496 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
497 If you find such a package installed on your system,
498 YOU did something horribly wrong! They are autogenerated
499 und used only by testcases for APT and surf no other propose…
510 local DEPENDENCIES
="$5"
512 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
514 local FILE
="${SPATH}/Sources"
518 Maintainer: Joe Sixpack <joe@example.org>
519 Architecture: $ARCH" >> $FILE
520 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
522 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
523 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
527 insertinstalledpackage
() {
531 local DEPENDENCIES
="$4"
532 local PRIORITY
="${5:-optional}"
533 local STATUS
="${6:-install ok installed}"
534 local FILE
='rootdir/var/lib/dpkg/status'
535 local INFO
='rootdir/var/lib/dpkg/info'
536 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
542 Maintainer: Joe Sixpack <joe@example.org>
543 Version: $VERSION" >> $FILE
544 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
545 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
546 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
547 If you find such a package installed on your system,
548 YOU did something horribly wrong! They are autogenerated
549 und used only by testcases for APT and surf no other propose…
551 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
552 echo -n > ${INFO}/${NAME}:${arch}.list
554 echo -n > ${INFO}/${NAME}.list
560 buildaptarchivefromincoming
() {
561 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
563 [ -e pool
] || ln -s ..
/incoming pool
564 [ -e ftparchive.conf
] || createaptftparchiveconfig
565 [ -e dists
] || buildaptftparchivedirectorystructure
566 msgninfo
"\tGenerate Packages, Sources and Contents files… "
567 aptftparchive
-qq generate ftparchive.conf
573 buildaptarchivefromfiles
() {
574 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
575 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
576 msgninfo
"\t${line} file… "
577 cat ${line} | gzip > ${line}.gz
578 cat ${line} | bzip2 > ${line}.bz2
579 cat ${line} | xz
--format=lzma
> ${line}.lzma
580 cat ${line} | xz
> ${line}.xz
586 # can be overridden by testcases for their pleasure
587 getcodenamefromsuite
() { echo -n "$1"; }
588 getreleaseversionfromsuite
() { true
; }
589 getlabelfromsuite
() { true
; }
591 generatereleasefiles
() {
592 # $1 is the Date header and $2 is the ValidUntil header to be set
593 # both should be given in notation date/touch can understand
594 msgninfo
"\tGenerate Release files… "
595 if [ -e aptarchive
/dists
]; then
596 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
597 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
598 local CODENAME
="$(getcodenamefromsuite $SUITE)"
599 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
600 local LABEL
="$(getlabelfromsuite $SUITE)"
601 if [ -n "$VERSION" ]; then
602 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
604 if [ -n "$LABEL" ]; then
605 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
607 aptftparchive
-qq release
$dir \
608 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
609 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
612 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
613 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
615 NotAutomatic: yes' $dir/Release
617 if [ -n "$1" -a "$1" != "now" ]; then
618 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
622 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
626 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
628 if [ -n "$1" -a "$1" != "now" ]; then
629 for release
in $(find ./aptarchive -name 'Release'); do
630 touch -d "$1" $release
636 setupdistsaptarchive
() {
637 local APTARCHIVE
=$(readlink -f ./aptarchive)
638 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
639 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
640 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
641 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
642 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
643 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
644 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
649 setupflataptarchive
() {
650 local APTARCHIVE
=$(readlink -f ./aptarchive)
651 if [ -f ${APTARCHIVE}/Packages
]; then
652 msgninfo
"\tadd deb sources.list line… "
653 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
656 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
658 if [ -f ${APTARCHIVE}/Sources
]; then
659 msgninfo
"\tadd deb-src sources.list line… "
660 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
663 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
669 if [ -e aptarchive
/dists
]; then
675 msgninfo
"\tSync APT's cache with the archive… "
681 local SIGNER
="${1:-Joe Sixpack}"
682 msgninfo
"\tSign archive with $SIGNER key… "
684 for KEY
in $(find keys/ -name '*.sec'); do
685 SECKEYS
="$SECKEYS --secret-keyring $KEY"
688 for KEY
in $(find keys/ -name '*.pub'); do
689 PUBKEYS
="$PUBKEYS --keyring $KEY"
691 for RELEASE
in $(find aptarchive/ -name Release); do
692 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
693 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
698 changetowebserver
() {
699 if which weborf
> /dev
/null
; then
700 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
702 elif which gatling
> /dev
/null
; then
704 gatling
-p 8080 -F -S 2>&1 > /dev
/null
&
707 elif which lighttpd
> /dev
/null
; then
708 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
710 server.stat-cache-engine = \"disable\"" > lighttpd.conf
711 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
712 lighttpd
-D -f lighttpd.conf
2>/dev
/null
>/dev
/null
&
715 msgdie
'You have to install weborf or lighttpd first'
718 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
719 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
720 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
726 mkdir -p rootdir
/media
/cdrom
/.disk
727 local CD
="$(readlink -f rootdir/media/cdrom)"
728 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
729 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
730 echo -n "$1" > ${CD}/.disk
/info
731 if [ ! -d aptarchive
/dists
]; then
732 msgdie
'Flat file archive cdroms can not be created currently'
735 mv aptarchive
/dists
$CD
736 ln -s "$(readlink -f ./incoming)" $CD/pool
737 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
741 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
742 if [ -n "$DIFFTEXT" ]; then
754 msgtest
"Test for correctness of file" "$FILE"
756 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
758 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
763 msgtest
"Test for no output of" "$*"
764 test -z "$($* 2>&1)" && msgpass
|| msgfail
768 local COMPAREFILE
=$(mktemp)
769 addtrap
"rm $COMPAREFILE;"
770 echo "$1" > $COMPAREFILE
772 msgtest
"Test for equality of" "$*"
773 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
777 local COMPAREFILE1
=$(mktemp)
778 local COMPAREFILE2
=$(mktemp)
779 local COMPAREAGAINST
=$(mktemp)
780 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
781 echo "$1" > $COMPAREFILE1
782 echo "$2" > $COMPAREFILE2
784 msgtest
"Test for equality OR of" "$*"
785 $
* 2>&1 1> $COMPAREAGAINST
786 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
787 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
788 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
789 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
794 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
797 while [ -n "$1" ]; do
799 N: Can't select versions from package '$1' as it is purely virtual"
800 PACKAGE
="${PACKAGE} $1"
803 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
805 N: No packages found"
806 local COMPAREFILE
=$(mktemp)
807 addtrap
"rm $COMPAREFILE;"
808 local ARCH
="$(getarchitecture 'native')"
809 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
810 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
814 msgtest
"Test for non-existent packages" "apt-cache show $*"
815 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
816 if [ -n "$SHOWPKG" ]; then
825 testdpkginstalled
() {
826 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
827 local PKGS
="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
828 if [ "$PKGS" != $# ]; then
830 dpkg
-l $
* | grep '^[a-z]'
837 testdpkgnotinstalled
() {
838 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
839 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
840 if [ "$PKGS" != 0 ]; then
842 dpkg
-l $
* | grep '^[a-z]'
850 local COMPAREFILE
=$(mktemp)
851 addtrap
"rm $COMPAREFILE;"
853 msgtest
'Test for correctly marked as auto-installed' "$*"
854 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
856 msgtest
'Test for correctly marked as auto-installed' 'no package'
857 echo -n > $COMPAREFILE
859 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
863 echo "STOPPED execution. Press enter to continue"